/*
	File: complex.dcl
	Project: CleanFloat
	Author: Shivkumar Chandrasekaran
	Email: shiv@ece.ucsb.edu
	Purpose: Complex numbers
	See also: CamlFloat
	Date: 6.17.2003
	
	$Id$
*/


definition module complex

import StdEnv

// Tuples cannot be unboxed in arrays. So use records. Cannot make this generic.
:: Complex = {re :: !Real, im :: !Real}

realPart :: !Complex -> Real
imagPart :: !Complex -> Real

(+:) infix 6 :: !Real !Real -> Complex
instance fromInt Complex
instance + Complex
instance - Complex
instance * Complex
instance zero Complex
instance one Complex
instance toString Complex
conjg :: !Complex -> Complex
